diff -ru File-Temp-0.17-orig/t/seekable.t File-Temp-0.17/t/seekable.t
--- File-Temp-0.17-orig/t/seekable.t	2006-08-19 00:15:22.000000000 +0200
+++ File-Temp-0.17/t/seekable.t	2006-11-21 14:22:14.523269473 +0100
@@ -21,7 +21,10 @@
 isa_ok( $tmp, 'IO::Seekable' );
 
 # make sure the seek method is available...
-ok( File::Temp->can('seek'), 'tmp can seek' );
+SKIP: {
+    skip "IO::Seekable is too old", 1 if IO::Seekable->VERSION <= 1.06;
+    ok( File::Temp->can('seek'), 'tmp can seek' );
+}
 
 # make sure IO::Handle methods are still there...
 ok( File::Temp->can('print'), 'tmp can print' );
diff -ru File-Temp-0.17-orig/Temp.pm File-Temp-0.17/Temp.pm
--- File-Temp-0.17-orig/Temp.pm	2006-08-19 00:24:51.000000000 +0200
+++ File-Temp-0.17/Temp.pm	2006-11-21 14:22:30.259729894 +0100
@@ -148,7 +148,7 @@
 # us that Carp::Heavy won't load rather than an error telling us we
 # have run out of file handles. We either preload croak() or we
 # switch the calls to croak from _gettemp() to use die.
-require Carp::Heavy;
+require Carp::Heavy if $] >= 5.006;
 
 # Need the Symbol package if we are running older perl
 require Symbol if $] < 5.006;
@@ -641,11 +641,12 @@
   # and suffixlen=0 returns nothing if used in the substr directly
   # Alternatively, could simply set $ignore to length($path)-1
   # Don't want to always use substr when not required though.
+  my $end = $] >= 5.006 ? "\\z" : "\\Z";
 
   if ($ignore) {
-    substr($path, 0, - $ignore) =~ s/X(?=X*\z)/$CHARS[ int( rand( $#CHARS ) ) ]/ge;
+    substr($path, 0, - $ignore) =~ s/X(?=X*$end)/$CHARS[ int( rand( $#CHARS ) ) ]/ge;
   } else {
-    $path =~ s/X(?=X*\z)/$CHARS[ int( rand( $#CHARS ) ) ]/ge;
+    $path =~ s/X(?=X*$end)/$CHARS[ int( rand( $#CHARS ) ) ]/ge;
   }
   return $path;
 }
